<?php
$form_departure_city = filter_input(INPUT_POST, "departure_city", FILTER_SANITIZE_STRING);
$form_departure_date = filter_input(INPUT_POST, "departure_date", FILTER_SANITIZE_STRING);
$form_arrival_city = filter_input(INPUT_POST, "arrival_city", FILTER_SANITIZE_STRING);
$form_arrival_date = filter_input(INPUT_POST, "arrival_date", FILTER_SANITIZE_STRING);
$form_date_now = filter_input(INPUT_POST, "date_now", FILTER_SANITIZE_STRING);
$action = filter_input(INPUT_POST, "action", FILTER_SANITIZE_STRING);

$oDepartureDate = new DateTime($form_departure_date);
$oArrivalDate = new DateTime($form_arrival_date);
$oDateNow = new Datetime($form_date_now);

/**
 * Sanity checks
 */

$input_failure = false;

if ($form_departure_city === $form_arrival_city) {
    echo "Departure and arrival city are the same. <br>";
    $input_failure = true;
}

if ($oDepartureDate < $oDateNow) {
    echo "The departure date is before the current date. <br>";
    $input_failure = true;
}

if (!($action === "return_flight") && $oArrivalDate <= $oDepartureDate) {
    echo "Arrival date is before departure date. <br>";
    $input_failure = true;
}

if (empty($form_arrival_date)) {
    // Limit to a 6 months interval from the departure date.
    $oArrivalDate = $oDepartureDate;
    $oArrivalDate->add(new DateInterval("P6M"));
    $form_arrival_date = $oArrivalDate->format('Y-m-d\TH:i');
}

?>

<h1> Rechercher un vol <?php if ($action === "return_flight") { echo "retour"; } ?> </h1>

<form action="index.php" id="search" method="post">
 <input type="hidden" name="form" value="search" />
 <?php if ($action === "return_flight") { echo "<input type=\"hidden\" name=\"action\" value=\"return_flight\" />"; } ?>
 <input type="hidden" name="date_now" value="<?php echo $form_date_now; ?>" />
 <label> De&#769;part : Ville -> </label>
 <select size="1" name="departure_city" required>
  <optgroup label="Se&#769;lectionner une ville">
 <?php
 $sql_pquery = "select distinct VilleD from VOLS order by VilleD";
 global $connection;
 $connection->prepare_query($sql_pquery);
 $connection->run_prepared_query();
 $connection->get_pquery_result();
 $cities = $connection->get_result_array();
 $connection->close_prepared_query();
 foreach ($cities as $city) {
     if (strcmp($city[0], $form_departure_city) === 0) {
         echo "<option value=\"$city[0]\" selected>$city[0]</option>\n";
     } else {
         echo "<option value=\"$city[0]\">$city[0]</option>\n";
     }
 }
 ?>
  </optgroup>
 </select>
 <label> Date -> </label>
 <input type="datetime-local" name="departure_date" value="<?php echo $form_departure_date; ?>" required/>
 <label> Arrive&#769;e : Ville -> </label>
 <select size="1" name="arrival_city" required>
  <optgroup label="Se&#769;lectionner une ville">
 <?php
 $sql_pquery = "select distinct VilleA from VOLS order by VilleA";
 global $connection;
 $connection->prepare_query($sql_pquery);
 $connection->run_prepared_query();
 $connection->get_pquery_result();
 $cities = $connection->get_result_array();
 $connection->close_prepared_query();
 foreach ($cities as $city) {
     if (strcmp($city[0], $form_arrival_city) === 0) {
         echo "<option value=\"$city[0]\" selected>$city[0]</option>\n";
     } else {
         echo "<option value=\"$city[0]\">$city[0]</option>\n";
     }
 }
 ?>
  </optgroup>
 </select>
 <label> Date -> </label>
 <input type="datetime-local" name="arrival_date" <?php if (isset($form_arrival_date)) { echo "value=\"$form_arrival_date\""; } ?> />
 <input type="submit" value="Rechercher">
</form>
<br>

<?php
if (!$input_failure) {
     global $connection;
     $sql_pquery = "select VOLS.NumVol as NumVol, VilleD, DateD, VilleA, DateA, Classe, round(CoutVol*CoeffPrix, 2) as Prix, NumAv from VOLS, DEFCLASSES
                    where DEFCLASSES.NumVol = VOLS.NumVol and
                    DateD >= ? and VilleD = ? and DateA <= ? and VilleA = ?
                    order by DateD, NumVol, Prix";
     $connection->prepare_query($sql_pquery);
     $connection->prepared_query_bind_param("ssss", array($form_departure_date, $form_departure_city, $form_arrival_date, $form_arrival_city));
     $connection->run_prepared_query();
     $connection->get_pquery_result();
     $rows = $connection->get_result_array();
     $connection->close_prepared_query();
     //FIXME: Use NumAv to see if a flight is fully booked.
     //var_dump($rows);
     if (empty($rows)) {
         echo "Aucun vol ne correspond aux crite&#768;res de recherche. <br>";
     } else {
         echo "<table id=\"search\">\n";
         echo "  <tr>\n";
         echo "    <th>Nume&#769;ro de vol</th>\n";
         echo "    <th>Ville de de&#769;part</th>\n";
         echo "    <th>Date de de&#769;part</th>\n";
         echo "    <th>Ville d'arrive&#769;e</th>\n";
         echo "    <th>Date d'arrive&#769;e</th>\n";
         echo "    <th>Classe</th>\n";
         echo "    <th>Prix d'une place</th>\n";
         echo "    <th>Re&#769;server</th>\n";
         echo "  </tr>\n";
         foreach ($rows as $row) {
             echo "  <tr>\n";
             echo "    <td>" . $row['NumVol'] . "</td>\n";
             echo "    <td>" . $row['VilleD'] . "</td>\n";
             echo "    <td>" . $row['DateD'] . "</td>\n";
             echo "    <td>" . $row['VilleA'] . "</td>\n";
             echo "    <td>" . $row['DateA'] . "</td>\n";
             echo "    <td>" . $row['Classe'] . "</td>\n";
             echo "    <td>" . $row['Prix'] . "&euro;</td>\n";
             echo "    <td>
                        <form action=\"index.php\" id=\"booking\" method=\"post\">
                          <input type=\"hidden\" name=\"form\" value=\"booking\" />
                          <input type=\"hidden\" name=\"flight_id\" value=\"" . $row['NumVol'] . "\" />
                          <input type=\"hidden\" name=\"class_name\" value=\"" . $row['Classe'] . "\" />
                          <input type=\"hidden\" name=\"place_price\" value=\"" . $row['Prix'] . "\" />
                          <label> Place(s) : </label>
                          <input type=\"number\" name=\"nb_place\" min=\"1\" max=\"9\" value=\"1\" required/>
                          <label> Vol retour : </label>\n";
             if (!($action === "return_flight")) {
                 echo "       <input type=\"checkbox\" name=\"return_flight\" checked/>\n";
             }
             echo "       <input type=\"submit\" value=\"Re&#769;server\">\n";
             echo "     </form>
                       </td>\n";
             echo "  </tr>\n";
         }
         echo "</table>\n";
     }
 }

?>
